# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      test_bpm.py
# Author:       toast
# Datetime:     2024/9/7 下午2:26
# Description:
# 
# ---------------------------------------------------------------------------

import allure
import pytest

from self_copy.apiAutoTest_v3 import log
from self_copy.apiAutoTest_v3.common.read_excel import ReadExcel
from self_copy.apiAutoTest_v3.test_case.toast import namespace


excel = ReadExcel(namespace)

class TestBPM:
    @allure.epic("BPM项目-toast")
    @pytest.mark.parametrize("module_name, api_name, level, title, url, method, mime, case_data, expect_data, sql_type, sql_data, update_key",excel.get_data())
    def test_bpm(self,fix_db,fix_req,module_name, api_name, level, title, url, method, mime, case_data, expect_data, sql_type, sql_data, update_key):
        allure.dynamic.feature(module_name)
        allure.dynamic.story(api_name)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)

        if sql_type == "delete":
            fix_db.delete(sql_data)

        elif sql_type == "select":
            select_result = fix_db.select(sql_data)
            case_data[update_key] = select_result

        elif sql_type == "select|delete" or sql_type == "delete|select":
            fix_db.delete(sql_data)

            select_result = fix_db.select(sql_data)
            case_data[update_key] = select_result

        res = fix_req.request_all(req_method=method, req_url=url, req_mime=mime, case_data=case_data)

        try:
            for key in expect_data.keys():
                assert expect_data[key] == res.json().get(key)
        except AssertionError:
            log.error(f"断言失败，接口url为：{url},用例数据：{case_data},期望数据：{expect_data},服务器返回数据：{res.text}")
            raise AssertionError("断言失败")
        else:
            log.info(f"断言成功，接口url为：{url},用例数据：{case_data},期望数据：{expect_data},服务器返回数据：{res.text}")

